#ifndef BOXITERATOR_H
#define BOXITERATOR_H

#include "Vect3d.h"

using namespace std;

//note the limits of iteration are included <= not <
class BoxIterator
{

   private:
   int x,y,z;
   int x_max, y_max, z_max;
   Vect3d<int> MinCorner, MaxCorner;

   public:
   BoxIterator(const Vect3d<int>& min_corner, const Vect3d<int>& max_corner);
   bool next();
   int getX() const;
   int getY() const;
   int getZ() const;
   Vect3d<int> * getVect3d() const;
};

inline bool BoxIterator::next()
{
   if (++x < x_max)
   {
      return true;
   }
   else
   {
      x = MinCorner.xcomp();
      if (++y < y_max)
      {
	 return true;
      }
      else 
      {
	 y = MinCorner.ycomp();
	 if (++z < z_max)
	 {
	    return true;
	 }
	 else
	    return false;
      }
   }
}

inline int BoxIterator::getX() const
{
   return x;
}

inline int BoxIterator::getY() const
{
   return y;
}

inline int BoxIterator::getZ() const
{
   return z;
}

inline Vect3d<int> * BoxIterator::getVect3d() const
{
   return new Vect3d<int>(x,y,z);
}

#endif//BOXITERATOR_H
