#ifndef RANDNUMGENERATOR
#define RANDNUMGENERATOR

#include "math.h"
#include "Vect3d.h"

#define NTAB 32

class RandNumGenerator{
   private: 
      long seed;
      long iy;
      long iv[NTAB];
      int iset;
      double gset;
   public:
   RandNumGenerator();
   RandNumGenerator(long seed);
   double nextFloat();
   int nextInt(int NumMon);
   double nextGaussian();
   void nextCircle(double &x, double &y);
   void nextSphere(vect_f & rand);
   vect_f * getGaussVect_f(double StdDev);
   void  getGaussVect_f(double StdDev, vect_f &rand);
   vect_f * getBoxVect_f(double x, double y, double z);
};

#endif
