#ifndef RUNGEKUTTA_H
#define RUNGEKUTTA_H
#include "RKable.h"

using namespace std;

class RungeKutta {
   private:
      double hh,h6,hsq,hsq02;;
      int n;
      int no2;//n/2
      vect_f * dym, *dyt, *dydt, *yt;
   public: 
      RKable * rkable;
      RungeKutta(int NumVar, double StepSize);
      void setRKable(RKable * rkable);
      double h;
      void rkpp(double t, vect_f * y, vect_f * yout);
      void Verlet(double t, vect_f * y, vect_f * yout);
      void DumbUpdate(double t, vect_f * y, vect_f * yout);
      double getStepSize();
};

inline void RungeKutta::setRKable(RKable * rkable) {
   this->rkable = rkable;
}



#endif//RUNGEKUTTA_H
