
import numpy
from scipy import *
from pylab import *
import time
import sys
import numpy as npy

def randdir():
    n = randint(6)
    return dir[n]

def randsphere(radius = 10.0):
    while 1:
        r = npy.random.random(3) - array((0.5,0.5,0.5))
        rsq = sum(r*r)
        if rsq < 1:
            return radius*r/sqrt(rsq)


def intrandsphere(radius): 
    return ceil(randsphere(radius))

def randplane(z,min_limits = (0,0),max_limits = (16,16)):
    x = min_limits[0] + randint(max_limits[0]-min_limits[0])
    y = min_limits[1] + randint(max_limits[1]-min_limits[1])
    return (x,y,z)

Seed = 10000
seed(Seed)
    
dir = array( [ [1,0,0], [-1,0,0], [0,1,0], [0,-1,0], [0,0,1], [0,0,-1]])

dims = (16,16)
center = (dims[0]/2,dims[1]/2)
abs_length = 6
abs_lengthO2 = abs_length/2
r = zeros((3))
graphics = 1
if graphics:
    from visual import *

starting_height = 16

num_absorbed = 0
num_escaped = 0


y_offset = -3
r_offset = array((0,y_offset,0))

if (graphics):
   abs_area = box (pos = (center[0],y_offset+center[1],0.5), length=abs_length, height=abs_length, width = 1.0, color=color.red)
   floor = box (pos = (center[0],y_offset+center[1],0.), length=dims[0], height=dims[1], width = 1.0, color=color.blue)
   ball = sphere (pos=(0,10+y_offset,0), radius=0.3, color=color.green)
   ion()

for i in range(1000000):
    r = randplane(starting_height, max_limits = dims)

    if graphics:
        ball.radius = 0.3
        ball.color = color.red

    while 1:

        if graphics:
            rate(10)
            ball.pos= r + r_offset


        if abs(r[0]-center[0]) <= abs_lengthO2 and abs(r[1]-center[1]) <= abs_lengthO2  and r[2] <= 0 :
            num_absorbed += 1
            if graphics or  num_absorbed % 100 == 0:
                print "num absorbed = ", num_absorbed
            if graphics:
                ball.color = color.white
            break
 
            key = scene.kb.getkey()
            if (key == 'q'): 
                break

        if r[2] > starting_height:
            num_escaped += 1
            if graphics or num_escaped % 100 == 0:
                print "num escaped = ", num_escaped, " num_absorbed/(num_absorbed+num_escaped) = ", num_absorbed/(1.0*num_absorbed+num_escaped) 
            break

        if  r[2] <= 0:
            r[2] = 1

        for xy in range(2):
            if r[xy] < 0:
                r[xy] = 1
            if r[xy] > dims[xy]:
                r[xy] = dims[xy] -1 

        r += randdir()

    

print "num_absorbed/(num_absorbed+num_escaped) = ", num_absorbed/(1.0*num_absorbed+num_escaped) 
