

from scipy import *
from pylab import *

C1 = 1/6.0
C2 = 1/12.0
Eps = 0

def diffuse(p, c1=C1, c2=C2, eps=Eps):
    tmp[:,:] = p[:,:]
    p[1:-1,1:-1] =  eps*p[1:-1,1:-1] + (1.-eps)*(c1*(p[0:-2,1:-1] + p[2:,1:-1] + p[1:-1,0:-2]+p[1:-1,2:])+c2*(p[0:-2,0:-2]+p[2:,2:]+p[0:-2,2:]+p[2:,0:-2]))
    
    p[0,1:-1] = eps*tmp[0,1:-1] + (1.-eps)*(c1*(2*tmp[1,1:-1] + tmp[0,0:-2] + tmp [0,2:]) + 2.0*c2*( tmp[1,2:] + tmp[1,0:-2]))
    p[1:-1,0] = eps*tmp[1:-1,0] + (1.-eps)*(c1*(2*p[1:-1,1] + tmp[0:-2,0] + tmp [2:,0]) + 2.0*c2*( tmp[2:,1] + tmp[0:-2,1]))
    p[0,0] =  eps*tmp[0,0] + (1.-eps)*(c1*(2*tmp[1,0] + 2*tmp[0,1]) + 4.0*c2* tmp[1,1])

    p[-1,1:-1] = eps*tmp[-1,1:-1] + (1.-eps)*(c1*(2*tmp[0,1:-1] + tmp[-1,0:-2] + tmp [-1,2:]) + 2.0*c2*( tmp[0,2:] + tmp[0,0:-2]))
    p[-1,0] =  eps*tmp[-1,0] + (1.-eps)*(c1*(2*tmp[0,0] + 2*tmp[-1,1]) + 4.0*c2* tmp[0,1])

    return


def set_cosine(arr,value,freq,ampl,const):
    for x in range(nx):
        y = ceil(ampl*cos(freq*x)+const)
        arr[x,0:y] = value

def set_square(arr,value,center,r):
   for x in range(-r,r): 
      for y in range(-r,r):
	 arr[center[0]+x,center[1]+y] = value
   return



nx = 128
ny = 256
dims = (nx,ny)
dt = 0.1
T0 = -1.0 
a= T0
phi_0 = -1.0 
C=0.5


dphi = zeros((nx,ny))
tmp = zeros((nx,ny))
T = a*ones(dims,dtype=float)
phi = phi_0*ones(dims,dtype=float)
freq = 2*pi*3./nx
set_cosine(phi,1.0,freq,2.,4.)
set_cosine(T,-0.2,freq,2,6.)
T += 0.01*standard_normal(dims)
phi += 0.01*standard_normal(dims)

ion()

for k in range(50000):
    diffuse(T)
    T[:,-1] = T0
    #diffuse_ani(phi)
    diffuse(phi,eps=0.5)
    #diffuse(phi,c1=0.1,c2=0.15,eps=0.75)
    #diffuse(phi,c1=0.35,c2=-0.1,eps=0.5)
    phi[:,-1] = -1.

    dphi =  -dt*(4*phi*(phi*phi-1)+T)
    phi += dphi
    T +=  C*dphi
    if 0 or k%50 == 0: 
#        T += 0.1*standard_normal(dims)
        imshow(phi, interpolation="nearest")
	draw()
        pause(0.0001)
        if (phi[4*nx/5,4*ny/5] > 0.2): break
  
show()
  


