import numpy
from scipy import *
from pylab import *
import time
from scipy import weave
from scipy.weave import converters

graphics = True

d = 2 #dimension of space (2d or 3d)

#seed(1010)
def potts(i,j):
    if i < 0 or j < 0:
	return 0
    else: 
	return V[i,j]
def sig(i):
     if i < 0:
         return 0
     else:
         return Sigma[i]

def en(i,r):
    e = 0
    for j in range(NN):
	e += potts(sig(i),sig(bead[(r+delta[j])&c31]))
    return e

def flip(R,Rmin,Sigma,NumIter,Beta):
   
      global Energy
      global energy_min
      beta = Beta;
      lm1 = l-1;
      for i in range(l):
          bead[R[i]&c31] = i
      for count in range(NumIter):
	  for n  in range(l):
	      if (Energy <= energy_min):
		  energy_min = Energy
		  Rmin[:] = R[:]
	      if n == 0: #  move tail
		  i = int(2*d*rand())
		  r1 = R[1]+delta[i]
		  if bead[r1&c31] == -1:
		      eold = en(0,R[0])
		      bead[R[0]&c31]=-1
		      bead[r1&c31] = 0
		      rold1=R[0]
		      R[0]=r1

		      e =  en(0,r1)
		      de = e-eold
		      if exp(-beta*de) > rand():
			  Energy += de
			  continue
		      bead[r1&c31] = -1;
		      R[0] = rold1;
		      bead[rold1&c31] = 0;
	      elif n == lm1:#  move head
		  i = int(2*d*rand())
		  r1 = R[lm1-1]+delta[i]
		  if bead[r1&c31] == -1:
		      eold = en(lm1,R[lm1])
		      bead[R[lm1]&c31] = -1
		      bead[r1&c31] = lm1
		      rold1 = R[lm1]
		      R[lm1]=r1;
		      e = en(lm1,r1)
		      de = e-eold
		      if exp(-beta*de) > rand():
			  Energy += de
			  continue
		      bead[r1&c31]=-1
		      R[lm1] = rold1
		      bead[rold1&c31]=lm1
	      else:
		  if  n > 1 and n < l-1 and rand() < 0.5:
		  # choose top hat move 
		      m=n-2
		      i=abs(R[m+3]-R[m])
		      if i == 1 or i == c1 or i == c2:
		          j=0
		          while (True):
			      i = i/c1
			      if i == 0:
				  break
			      j += 1
			  r1=R[m]+w[j][int(2*(d-1)*rand())]
			  r2=r1+R[m+3]-R[m]
			  if bead[r1&c31] == -1 and bead[r2&c31] == -1:
			      e1 = en(m+1,R[m+1])
			      e2 = en(m+2,R[m+2])
			      eold = e1+e2
			      bead[R[m+1]&c31]=bead[R[m+2]&c31] = -1
			      bead[r1&c31] = m+1
			      bead[r2&c31] = m+2
			      rold1=R[m+1]
			      rold2=R[m+2]
			      R[m+1] = r1
			      R[m+2] = r2
			      e1 = en(m+1,r1)
			      e2 = en(m+2,r2)
			      de =  e1 + e2 - eold;
			      if exp(-beta*de) > rand():
				  Energy += de;
				  continue;
			      bead[r1&c31]=bead[r2&c31]=-1
			      R[m+1] = rold1
			      R[m+2] = rold2
			      bead[rold1&c31] = m+1
			      bead[rold2&c31] = m+2

		  else:  #choose right angle move 
		      m=n-1
		      r_new = R[m+2]+R[m] - R[m+1]
		      if bead[r_new&c31] == -1:
			  eold = en(m+1,R[m+1])
			  bead[R[m+1]&c31]=-1
			  bead[r_new&c31]= m+1 
			  rold1=R[m+1]
			  R[m+1] = r_new
			  e = en(m+1,r_new)
			  de = e-eold;
			  if exp(-beta*de) > rand():
			      Energy += de
			      continue;
			  bead[r_new&c31]=-1
			  R[m+1]=rold1
			  bead[rold1&c31]=m+1

   
      return

#The energy of a chain:
def energy(R,Sigma):
    e = 0
    l = size(Sigma)
    for i in range(l):
	for j in range(i+1,l):
            delta = sum((R[i]-R[j])**2) - 1
	    if sum((R[i]-R[j])**2) ==1:
		e += V[Sigma[i]][Sigma[j]]
    return e

#In the definition of energy in the HP model, they subtract off the energy between nearest
#neighbors along the backbone because this never changes:
def backbone_energy(Sigma):
    e=0
    l = size(Sigma)
    for i in range(l-1):
	e += V[Sigma[i]][Sigma[i+1]]
    return e

	
def convert_1d_to_3d(R,r):
    r[0,:] = 0
    l = size(R)
    for i in range(1,l):
	delta = R[i]-R[i-1]
	if abs(delta) < box_size:
	    r[i] = r[i-1] + delta*dir[0]
	elif abs(delta) < box_size**2:
	    r[i] = r[i-1] + int(delta/box_size)*dir[2]
	else:
	    r[i] = r[i-1] + int(delta/(box_size*box_size))*dir[4]
    return

def init_chain(R,box_size):
    index = 0
    R[0] = 0
    line_length = box_size/2
    direction = 1
    while True:
        for j in range(line_length):
            R[index + 1] = R[index] + direction
            index += 1
            if index == l-1:
                return
        R[index + 1] = R[index] + box_size
        index += 1
        if index == l-1:
            return
        R[index + 1] = R[index] +  box_size
        index += 1
        if index == l-1:
            return
        direction *= -1
    return


dir = array([ [1,0,0], [-1,0,0], [0,1,0], [0,-1,0],[0,0,1],[0,0,-1]], dtype = int)
# Here there are only two types of amino acids:
nstates=2
#The 1's are H's and the P's are 2's.
Sigma = array([1,2,2,1,2,1,2,2,1,2,2,1,2])

#V describes the nearest neighbor interaction between the different types amino acid. 
V = zeros((nstates+1,nstates+1))
# Here we're looking at the HP model, so the only non-zero energy is when to H's are
#next to each other.
V[1,1] = -1.0
#If you wanted to, you could add extra energies as well, but that's not done in th HP model.
#V[1,2] = -3.3
#V[2,2] = -2.6


#Length of chain:
l = size(Sigma)
print "length l = ", l
#Beta = 1/Temperature:
Beta = 3.0
#For efficiency sake, we put the whole thing in a box, but you probably won't have to worry about this:
box_size = 32
#We also use a 1d representation of the chain, again you shouldn't have to worry about this:
R = array(range(0,l), dtype=int) #1d representation of 3d coords r:
Rmin = array(range(0,l), dtype=int) #1d representation of 3d coords rmin:
#The "real" 3d representation of the chain:
r = zeros((l,3), dtype=int)
#The minimum energy configuration found:
rmin = zeros((l,3), dtype=int)
           
#Setting up a bunch of stuff to do the monte carlo simulation in flip() You can ignore 
#this.
c1 = box_size
c2 = c1*c1;
c3=c2*c1 
c31=c3-1

bead = -1 * ones((c3),dtype = int)
delta = zeros((6), dtype = int)
w = zeros((3,4),dtype = int)
NN= 2*d

delta[0] = 1
delta[1] = -1
delta[2] = c1
delta[3] = -c1
delta[4] = c2
delta[5] = -c2
w[0][0]=c1;w[0][1]=-c1;w[0][2]=c2;w[0][3]=-c2;
w[1][0]=1; w[1][1]=-1; w[1][2]=c2;w[1][3]=-c2;
w[2][0]=1; w[2][1]=-1; w[2][2]=c1;w[2][3]=-c1;
#


#Make a chain (in it's weird 1d representation:
init_chain(R,box_size)
#convert this to 3d in order to see it:
convert_1d_to_3d(R,r)
    

#The usual ion() command you need to invoke with scipy when you have graphics:
ion()
#Set up the 3d graphics:
if graphics:
    from visual import *
    ball = []
    cyl = []
    for i in range(l):
	if i < l-1:
	    cyl.append(cylinder (pos=r[i], axis=r[i+1]-r[i], color=color.white, radius = 0.2, opacity = 0.5))
	if Sigma[i] == 1:
	    col = color.red
	else:
	    col = color.green
	ball.append(sphere(pos=r[i],color=col,radius=.3))
 
def show_chain(r):
        #rate(4)
        for k in range(l-1):
            cyl[k].pos = r[k]
            cyl[k].axis = r[k+1]-r[k]
            ball[k].pos = r[k]
        ball[l-1].pos = r[l-1]

   
convert_1d_to_3d(R,r)
#The energy of a chain:
Energy = energy(r,Sigma)

#sys.exit(0)

energy_min = 1e6
#In the definition of energy in the HP model, they subtract off the energy between nearest
#neighbors along the backbone because this never changes:
b_e = backbone_energy(Sigma)

#Now do "simulated annealing". You cool down the chain as time progesses and you spend more
#time at lower temperatues (larger beta). You can adjust these parameters.
#See the use below. At every step of the annealing process, you increase beta by b0 and the
#time spent doing the simulation by t0.
beta = 1.0
b0 = 1.1
t0 = 1.2
#The inital time spend doing the simulation at the initial inverse temperature, beta.
time = 10
#Used to know how often to refresh the display:
count = 0
while beta < 10.0 and energy_min > -4:
    count += 1
    beta *= b0
    time *= t0
    n_tries = int(time);
    print "beta = ", beta, "n_tries = ", n_tries
    #Now this is where all the work is done:
    flip(R,Rmin,Sigma,n_tries,beta)
    #use this to see how it looks in real 3d space:
    convert_1d_to_3d(R,r)
    if  Energy != energy(r,Sigma): #This shouldn't ever get hit:
        print "ERROR!!!: Energy = ", Energy, "Energy from energy() = ", energy(r,Sigma)
    print "Energy = ", Energy-b_e, "min E = ", energy_min-b_e

    #Rmin is the 1d and rmin is the 3d configuration of the chain found in the lowest energy state:
    convert_1d_to_3d(Rmin,rmin)


    if graphics and count%1 == 0:
	rate(2)
	#You can replace rmin by r, to see the chain as it is presently. This shows the minimum
	#energy configuration found up to now.
	show_chain(rmin)

