
from scipy import *
from pylab import *


#load in the slices of an image 
slices = loadtxt("tom.txt.gz") #slices(angle,radius)
#gets the linear dimensions of slices. slices.shape does the same.
n = len(slices)
m = size(slices)//n
#center of the image (in this case it's square, m=n)
center = (m//2,n//2)

f = zeros((n,m),dtype=complex)
count = zeros((n,m))

sign = ones(n)
for x in range(1,n,2): sign[x] = -1;


for i_theta in range(0,n):
#sign is there because of the shift theorem for fourier transforms, giving exp(i n pi) terms
   f_slice = fft(slices[i_theta,:])*sign
   theta = i_theta*pi/n
#  Shift the fourier transform so the center is (m/2,m/2)
   for i_r in range(0,m//2):
      x = center[0] # + involves i_r and theta 
      y = center[1] # + involves i_r and theta 
      count[x,y] += 1
      f[x,y] += f_slice[i_r]

#     The negative frequencies are obtained from the k-values > m/2
      x = center[0]  # + involves (i_r-m//2 and theta)
      y = center[1]  #+ involves (i_r-m//2) and theta
      f[x,y] += f_slice[i_r+m//2]
      count[x,y] += 1

#This shifts indices of an FFT so that they're properly centered around n/2
#and is used below
def shift_ft(x,n):
   if x < n//2: return x+n//2
   return x-n//2

g = zeros((n,m),dtype=complex)
for x in range(0,n):
   for y in range(0,m):
      if count[x,y] > 0: 
         g[shift_ft(x,n),shift_ft(y,n)] # =  should involve sign to center the image, f[x,y] and count

#invert
h=ifft2(g)


colormap = cm.gist_gray
imshow(real(h),interpolation="nearest",cmap=colormap)
show()




