

from scipy import *
from pylab import *


C1 = 1/6.0
C2 = 1/12.0
Dt = 0.3

def diffuse(p, c1=C1, c2=C2, dt=Dt):
    #p[1:-1,1:-1] = c1*(p[0:-2,1:-1] + p[2:,1:-1] + p[1:-1,0:-2] + p [1:-1,2:]) + c2*(p[0:-2,0:-2] + p[2:,2:] + p[0:-2,2:] + p[2:,0:-2])
    p[1:-1,1:-1] =  (1-dt)*p[1:-1,1:-1] + dt*(c1*(p[0:-2,1:-1] + p[2:,1:-1] + p[1:-1,0:-2] + p [1:-1,2:]) + c2*(p[0:-2,0:-2] + p[2:,2:] + p[0:-2,2:] + p[2:,0:-2]))
    return



def set_circle(arr,value,center,r):
   for x in range(-r,r):
      for y in range(-r,r):
         if (x**2+y**2) > r**2: continue
         arr[center[0]+x,center[1]+y] = value
   return



nx = 128
ny = 128
dims = (nx,ny)
middleT=[0,]
time = [0]



T = ones(dims,dtype=float)

set_circle(T,0.0,(nx//2,ny//2),8)

ion()
figure(0)
for k in range(400):
    diffuse(T)
    if (k%10 == 0): 
        imshow(T)
        draw()
        pause(0.0001)
        middleT.append(T[nx//2,ny//2])
        time.append(k*Dt)
figure(1)
plot(time,middleT)
xlabel("t")
ylabel("I")

save = zeros((len(time),2))
save[:,0] = time[:]
save[:,1] = middleT[:]
savetxt("grap_comparison.txt",save)


show()
pause(1)
